;-------------------------------------------------------------------------------------------------------------------------
;    .
; : .., ., 2008.
;     (Main.asm): 480 .
;   : 711Ch (   PonyProg2000;   eeprom).
; 1   ,  2 - .
;-------------------------------------------------------------------------------------------------------------------------

;  (    0;   'Configuration and Security bits'  PonyProg2000     ):
  ;JTAGEN                JTAG 
  ;SPIEN                 SPI 
  ;BOOTSZ0..1               (1024 ; 14334   )
  ;BODEN                  
  ;SUT0                        SUT1     (65)
  ;CKSEL3 CKSEL2 CKSEL1        CKSEL0      RC    1
;  (    1;   'Configuration and Security bits'  PonyProg2000      ):
  ;OCDEN                   (  )
  ;EESAVE                EEPROM      
  ;CKOPT                        RC 
  ;BOOTRST                Reset     (  $0000)
  ;BODLEVEL                 2,7  ( ATmega16   L      ,    4,0)
  ;SUT1                        SUT0     (65)
  ;CKSEL0                      CKSEL3...1      RC    1
;    (Lock bits)   (  ).

; :
  ;b  - 
  ;  - 
  ;e  -  EEPROM
  ;eb -  EEPROM
  ;m  -  SRAM
  ;mb -  SRAM
  ;me -  SRAM,     EEPROM
  ;r  - 
  ;re - ,     EEPROM
  ;s  - 
  ;sb - 
  ;p  -  /

;.nolist                        ;    .
.include "m16def.inc"           ;    ,     
                                ;(       )
  ; :
;                            R0  
;                            R1   mul.
;                            R2    EepromWriteIfDifferent.
.def    rSoftTurnSpeedCh1  = R3  ; ,          1.
.def    rSoftTurnSpeedCh2  = R4  ; ,          2.
.def    rBrightCounterCh1  = R5  ; ,      1.
.def    rBrightCounterCh2  = R6  ; ,      2.
.def    reBrightChangeSpeedCh1 = R7 ;     1   .
.def    reBrightChangeSpeedCh2 = R8 ;     2   .
.def    rSoftOffBrightCh1  = R9  ;,       1    .
.def    rSoftOffBrightCh2  = R10 ;,       2    .
.def    rCh1OffTime        = R11 ;,     1    .
.def    rCh2OffTime        = R12 ;,     2    .
.def    rTotalVoltage1_3   = R13 ;     1.
.def    rTotalVoltage1_2   = R14 ;     1.
.def    rTotalVoltage1_1   = R15 ;     1.
.def    rTotalVoltage2_3   = R16 ;     2.
.def    rTotalVoltage2_2   = R17 ;     2.
.def    rTotalVoltage2_1   = R18 ;     2.
.def    Temp               = R19 ;     (     R16-R31).
.def    Tmp                = R20 ;     (     R16-R31).
.def    rBrightnessCh1     = R21 ;    1.
.def    rBrightnessCh2     = R22 ;    2.
.def    rButton1HoldTime   = R23 ;    1.
.def    rButton2HoldTime   = R24 ;    2.
.def    rOutChannels       = R25 ; .
.def    reSystemBits       = R26 ;    eSystemBits.
.def    reUserBits1        = R27 ;    eUserBits1.
.def    reUserBits2        = R28 ;    eUserBits2.
.def    rBit1              = R29 ; :
  .equ    bSoftTurnCh1       = 0   ;,   /  1 (  1).
  .equ    bSoftTurnCh2       = 1   ;,   /  2 (  1).
  .equ    bIsChannel1On      = 2   ;    1 ( 1,  ).
  .equ    bIsChannel2On      = 3   ;    2 ( 1,  ).
  .equ    bBrightVectorCh1   = 4   ;   1 ( 1      ,  0 - ).
  .equ    bBrightVectorCh2   = 5   ;   2 ( 1      ,  0 - ).
  .equ    bTurnOffStartedCh1 = 6   ;,   1     (  1)
  .equ    bTurnOffStartedCh2 = 7   ;,   2     (  1)
;                            R30     ,
;                            R31    ,     .

  ; :
.equ    pMainOut        = PORTA  ;  .
  .equ    bChannel1     = 0      ; 1 ( 0).
  .equ    bChannel2     = 1      ; 2 ( 1).
.equ    pKeyboardIn     = PIND   ;  .
  .equ    sbChannel1    = 0      ;    1.
  .equ    sbChannel2    = 1      ;    2.

  ;,   :
.equ    cADCSamplesCount   = 434 ;     (   ADCSampling).
.equ    cButtonOnHoldSense = 100 ;  ,        (. 254).     , ..     ,      10. ..     100,    1 .
.equ    cMinBrightOAH      = 50  ;   .
.equ    cMaxDurationOAH    = 240 ;            (  ).


  ; EEPROM:
.eseg                            ;    eeprom,       VMLab,  16   .
.org $0010                       ;  eeprom:
eUserBits1:             .db  (1<<ebTurnPrevStateCh1)+(0<<ebTurnPrevStateCh2)+(1<<ebBrightDirModeCh1)+(0<<ebBrightDirModeCh2)+(0<<ebAutoOffModeCh1)+(1<<ebAutoOffModeCh2)+(1<<ebRandomOAH)
  .equ  ebTurnPrevStateCh1 = 7   ;     1    ( 1,  )
  .equ  ebTurnPrevStateCh2 = 6   ;     2    ( 1,  )
  .equ  ebBrightDirModeCh1 = 5   ;    1.    0     ,  1 -    .
  .equ  ebBrightDirModeCh2 = 4   ;    2.    0     ,  1 -    .
  .equ  ebAutoOffModeCh1   = 3   ;   1      ( 0   -   ;  1   -     ).
  .equ  ebAutoOffModeCh2   = 2   ;   2      ( 0   -   ;  1   -     ).
  .equ  ebRandomOAH        = 1   ;   ,           (OAH - OwnersAtHome;     1).
eUserBits2:             .db  (1<<ebSaveBrightM1Ch1)+(0<<ebSaveBrightM2Ch1)+(0<<ebSaveBrightM1Ch2)+(1<<ebSaveBrightM2Ch2)
  .equ  ebSaveBrightM1Ch1 = 7    ;     1 (   1,   ).
  .equ  ebSaveBrightM2Ch1 = 6    ;     1 (   1,   ).
  .equ  ebSaveBrightM1Ch2 = 5    ;     2 (   1,   ).
  .equ  ebSaveBrightM2Ch2 = 4    ;     2 (   1,   ).

eLastBright1_1:         .db  50  ; (  )   1   .
eLastBright1_2:         .db  200 ; (  )   1   .
eLastBright2_1:         .db  100 ; (  )   2   .
eLastBright2_2:         .db  167 ; (  )   2   .

eTurnOnSpeedMode1Ch1:   .db  1   ;        1 ( 1  5 . .).   ,     .
eTurnOnSpeedMode2Ch1:   .db  3   ;        1 ( 1  5 . .).   ,     .
eTurnOffSpeedMode1Ch1:  .db  5   ;        1 ( 1  5 . .).   ,     .
eTurnOffSpeedMode2Ch1:  .db  5   ;        1 ( 1  5 . .).   ,     .
eTurnOnSpeedMode1Ch2:   .db  5   ;        2 ( 1  5 . .).   ,     .
eTurnOnSpeedMode2Ch2:   .db  1   ;        2 ( 1  5 . .).   ,     .
eTurnOffSpeedMode1Ch2:  .db  2   ;        2 ( 1  5 . .).   ,     .
eTurnOffSpeedMode2Ch2:  .db  1   ;        2 ( 1  5 . .).   ,     .

eBrightnessMinCh1:      .db  35  ;   1 (        eBrightnessMaxCh1).
eBrightnessMaxCh1:      .db  200 ;   1 (   eBrightnessMinCh1).
eMinBrightDelayCh1:     .db  100 ;     1 ( 0  255   ).
eMaxBrightDelayCh1:     .db  150 ;     1 ( 0  255   ).
eBrightnessMinCh2:      .db  36  ;   2 (        eBrightnessMaxCh2).
eBrightnessMaxCh2:      .db  222 ;   2 (   eBrightnessMinCh2).
eMinBrightDelayCh2:     .db  200 ;     2 ( 0  255   ).
eMaxBrightDelayCh2:     .db  250 ;     2 ( 0  255   ).

eBrightChangeSpeedCh1:  .db  4   ;    1 ( 1  5 . .).   ,   .
eBrightChangeSpeedCh2:  .db  2   ;    2 ( 1  5 . .).   ,   .

eOffTimeoutHoursCh1:    .db  2   ;      1 ( 1  24 ).
eOffTimeMode1Ch1:       .db  94  ;         1   ( 1  255 . .). = * 0,01 * rBrightnessCh1. ,    94    64      94*0,01*64=60 .
eBrightDecrPercentCh1:  .db  25  ;      1      ( 10  90 ).
eOffTimeMode2Ch1:       .db  10  ;     1           ( 1  240 ).
eOffTimeoutHoursCh2:    .db  5   ;      2 ( 1  24 ).
eOffTimeMode1Ch2:       .db  15  ;         2   ( 1  255 . .). = * 0,01 * rBrightnessCh2. ,    15    64      15*0,01*64=10 .
eBrightDecrPercentCh2:  .db  50  ;      2      ( 10  90 ).
eOffTimeMode2Ch2:       .db  5   ;     2           ( 1  240 ).

eOwnersAtHomeBright:    .db  128 ;    ( cMinBrightOAH  255 . .).
eOwnersAtHomeOnPeriod:  .db  8   ;      ( 1  cMaxDurationOAH ).
eOwnersAtHomeOffPeriod: .db  6   ;      ( 1  cMaxDurationOAH ).


;.byte 2
.org $003C                       ; (  )  eeprom:
eSystemBits:            .db  (0<<ebPowerStateCh1)+(0<<ebPowerStateCh2)+(0<<ebChannel1Mode)+(0<<ebChannel2Mode)+(0<<ebOwnersAtHome)
  .equ  ebPowerStateCh1    = 7     ;  1 (  1   )
  .equ  ebPowerStateCh2    = 6     ;  2 (  1   )
  .equ  ebChannel1Mode     = 5     ;  1 (     -  1,   0;    -  2,   1)
  .equ  ebChannel2Mode     = 4     ;  2 (     -  1,   0;    -  2,   1)
  .equ  ebOwnersAtHome     = 3     ;    (  1   ).

MajorFirmwareVersion:   .db  2   ;
MinorFirmwareVersion:   .db  14  ;
BuildRevision:          .db  05  ;(  ..).

                                 ; eeprom c  :
.org    EEPROMEND - 1            ;,   ,         EEARH=$01  EEARL=$FF.
eWrongINT:              .db  0   ;   .
.org    EEPROMEND - 2
eJTAGReset:             .db  0   ;    JTAG.
.org    EEPROMEND - 3
eWatchdogReset:         .db  0   ;      .
.org    EEPROMEND - 4
eBrownOutReset:         .db  0   ;  -   
.org    EEPROMEND - 5            ;( , ..       ).
eExternalReset:         .db  0   ;        Reset.
.org    EEPROMEND - 6
ePowerOnReset:          .db  0   ;    
                                 ;( , ..       ).

  ; SRAM:
.dseg
;mDummy:                .byte 1  ;   .    .

mSeed:                  .byte 1  ;    .

meTurnOnSpeedMode1Ch1:  .byte 1  ;         1.
meTurnOnSpeedMode2Ch1:  .byte 1  ;         1.
meTurnOffSpeedMode1Ch1: .byte 1  ;         1.
meTurnOffSpeedMode2Ch1: .byte 1  ;         1.
meTurnOnSpeedMode1Ch2:  .byte 1  ;         2.
meTurnOnSpeedMode2Ch2:  .byte 1  ;         2.
meTurnOffSpeedMode1Ch2: .byte 1  ;         2.
meTurnOffSpeedMode2Ch2: .byte 1  ;         2.

meLastBright1_1:        .byte 1  ;    1   .
meLastBright1_2:        .byte 1  ;    1   .
meLastBright2_1:        .byte 1  ;    2   .
meLastBright2_2:        .byte 1  ;    2   .

mSaveBrightDelayCh1:    .byte 1  ;     2,5.     1  eeprom.
mSaveBrightDelayCh2:    .byte 1  ;     2,5.     2  eeprom.

mOffTimeoutSecondCh1:   .byte 1  ;      1.
mOffTimeoutMinuteCh1:   .byte 1  ;      1.
mOffTimeoutHourCh1:     .byte 1  ;      1.
meOffTimeoutHourCh1:    .byte 1  ;      1.
meOffTimeoutHoursCh1:   .byte 1  ;  ,      1.
mOffSharedCellCh1:      .byte 1  ; ,      1.
meOffTimeMode1Ch1:      .byte 1  ;     1    .
meOffTimeMode2Ch1:      .byte 1  ; ,     1      .
meBrightDecrPercentCh1: .byte 1  ;     1   .
mOffTimeoutSecondCh2:   .byte 1  ;      2.
mOffTimeoutMinuteCh2:   .byte 1  ;      2.
mOffTimeoutHourCh2:     .byte 1  ;      2.
meOffTimeoutHourCh2:    .byte 1  ;      2.
meOffTimeoutHoursCh2:   .byte 1  ;  ,      2.
mOffSharedCellCh2:      .byte 1  ; ,      2.
meOffTimeMode1Ch2:      .byte 1  ;     2    .
meOffTimeMode2Ch2:      .byte 1  ; ,     2      .
meBrightDecrPercentCh2: .byte 1  ;     2   .

meOwnersAtHomeBright:   .byte 1  ;       ().
meOwnersAtHomeOnPeriod: .byte 1  ;      .
meOwnersAtHomeOffPeriod:.byte 1  ;      .
mOwnersAtHomeSharedCell:.byte 1  ;  .    meOwnersAtHomeOnPeriod,   meOwnersAtHomeOffPeriod.
mOwnersAtHomeSeconds:   .byte 1  ;  ,    .
mOwnersAtHomeMinutes:   .byte 1  ;  ,    .

meBrightnessMinCh1:     .byte 1  ;   1.
meBrightnessMaxCh1:     .byte 1  ;   1.
meMinBrightDelayCh1:    .byte 1  ;      1.
meMaxBrightDelayCh1:    .byte 1  ;      1.
mBrightMinCounterCh1:   .byte 1  ;      1.
mBrightMaxCounterCh1:   .byte 1  ;      1.
meBrightnessMinCh2:     .byte 1  ;   2.
meBrightnessMaxCh2:     .byte 1  ;   2.
meMinBrightDelayCh2:    .byte 1  ;      2.
meMaxBrightDelayCh2:    .byte 1  ;      2.
mBrightMinCounterCh2:   .byte 1  ;      2.
mBrightMaxCounterCh2:   .byte 1  ;      2.


.cseg
.org    $0000
        rjmp RESET                              ;Reset Handler.
.org    INT0addr
        rjmp WrongINT           ;EXT_INT0       ;IRQ0 Handler.
.org    INT1addr
        rjmp WrongINT           ;EXT_INT1       ;IRQ1 Handler.
.org    OC2addr
        rjmp WrongINT           ;TIM2_COMP      ;Timer2 Compare Handler.
.org    OVF2addr
        rjmp WrongINT           ;TIM2_OVF       ;Timer2 Overflow Handler.
.org    ICP1addr
        rjmp WrongINT           ;TIM1_CAPT      ;Timer1 Capture Handler.
.org    OC1Aaddr
        rjmp WrongINT           ;TIM1_COMPA     ;Timer1 CompareA Handler.
.org    OC1Baddr
        rjmp WrongINT           ;TIM1_COMPB     ;Timer1 CompareB Handler.
.org    OVF1addr
        rjmp WrongINT           ;TIM1_OVF       ;Timer1 Overflow Handler.
.org    OVF0addr
        rjmp WrongINT           ;TIM0_OVF       ;Timer0 Overflow Handler.
.org    SPIaddr
        rjmp WrongINT           ;SPI_STC        ;SPI Transfer Complete Handler.
.org    URXCaddr
        rjmp WrongINT           ;USART_RXC      ;USART RX Complete Handler.
.org    UDREaddr
        rjmp WrongINT           ;USART_UDRE     ;UDR Empty Handler.
.org    UTXCaddr
        rjmp WrongINT           ;USART_TXC      ;USART TX Complete Handler.
.org    ADCCaddr
        rjmp WrongINT           ;ADC_COMPLETE   ;ADC Conversion Complete Handler.
.org    ERDYaddr
        rjmp WrongINT           ;EE_RDY         ;EEPROM Ready Handler.
.org    ACIaddr
        rjmp WrongINT           ;ANA_COMP       ;Analog Comparator Handler.
.org    TWIaddr
        rjmp WrongINT           ;TWSI           ;Two-wire Serial Interface Handler.
.org    INT2addr
        rjmp WrongINT           ;EXT_INT2       ;IRQ2 Handler.
.org    OC0addr
        rjmp WrongINT           ;TIM0_COMP      ;Timer0 Compare Handler.
.org    SPMRaddr
        rjmp WrongINT           ;SPM_RDY        ;Store Program Memory Ready Handler.

.org     $002A
.include "Macros.asm"
.include "Reset.asm"
.include "SRAMInit.asm"
.include "Startup.asm"
.include "Main.asm"
.include "ProceduresINT.asm"
.include "ProceduresEXT.asm"
.include "WrongINT.asm"
.include "Tables.asm"
